#include <qwidget.h>
#include <qpushbt.h>
#include <qcombo.h>
#include <qslider.h>
#include <qchkbox.h>
#include <qlined.h>
#include <qframe.h>
#include <qmlined.h>

class colTab:public QWidget
{
  Q_OBJECT
public:
  colTab(QWidget* parent = NULL,const char* name = NULL,bool colors=TRUE);
  virtual ~colTab();
  void setBack(QColor val)
  {
    back=val;
    QPalette palette(val);
    bColor->setPalette(palette);
    bColor->repaint();
  }
  QColor getBack(){return back;}
  void setFore(QColor val)
  {
    fore=val;
    QPalette palette(val);
    fColor->setPalette(palette);
    fColor->repaint();
  }
  void setCFont(QFont val);
  QFont getCFont(){return sFont;}
  QColor getFore(){return fore;}
public slots:
  void selectorB();
  void selectorF();
  void setFamily(const char *val);
  void setSize(const char *val);
  void setItBold(bool val);
  void setItItalic(bool val);
private:
  QColor back,fore;
  QPushButton *bColor,*fColor;
  QComboBox *Fsize,*Fstyle,*Ffamily;
  QCheckBox *italic,*normal,*bold;
  QMultiLineEdit *tasteIt;
  QString *family;
  int psize;
  QFont sFont;

  void writeTest();
};

//selector
class cSel: public QFrame
{
  Q_OBJECT
public:
  cSel(colTab *par=NULL,const char* name = NULL);
  virtual ~cSel();
  void setColor(QColor val);
  void setWhat(int val){what=val;}
  void refresh();
public slots:
  void putColor(QColor val){setColor(val);}
  void seyOK();
  void seyBye();
  void mr();
  void rSet(int val);
  void rSet(const char *val);
  void gSet(int val);
  void gSet(const char *val);
  void bSet(int val);
  void bSet(const char *val);
protected:
  colTab *toChange;
  int what,way,r,g,b;
  QPushButton *b1,*b2,*b3,*b4,*b5,*b6,*b7,*b8,*b9,*b10,*b11,*b12,*b13,*b14,*b15,*b16,*b17,*b18,*b19,*b20,*b21,*b22,*b23,*b24,*more,*ok,*csl;
  QFrame *color;
  QSlider *rSlide,*gSlide,*bSlide;
  QLineEdit *rVal,*gVal,*bVal;
};

//color button
class colorButton:public QPushButton
{
  Q_OBJECT
public:
  colorButton(QWidget * parent=0, const char * name=0 ):QPushButton(parent,name){}
signals:
  void cPress(QColor val);
private:
  void mousePressEvent(QMouseEvent *event)
  {    emit cPress(this->backgroundColor());}  
};





